#include <users.h>

gboolean us_user_login(gint argc,gchar *argv[]) {
  
  gboolean rv = FALSE;

  if(argc == 3) {
    User *u = user_get(((Server*)argv[argc+1])->users,argv[0]);
    if(u != NULL) {
      if((rv = user_add(((Server*)argv[argc+1])->users,u))) {
        u->user_state = us_parse_state_enum_arg(argv[2]);
      }
    } else {
      u = user_new_with_values(g_strdup(argv[0]),
			       g_strdup(argv[1]),
			       (Connection*)argv[3]);
      if((rv = user_add(((Server*)argv[argc+1])->users,u))) {
        u->user_state = us_parse_state_enum_arg(argv[2]);
      }
    }

  } else {
    gchar *str = 
      g_strdup_printf(_("wrong number of arguments got %d need %d"),argc,3);
    g_warning(str);
    g_free(str);    
  }

  return rv;

}

gboolean us_user_logout(gint argc,gchar *argv[]) {
  
  gboolean rv = FALSE;

  if(argc == 2) {
    User *u = user_get(((Server*)argv[argc+1])->users,argv[0]);
    
    if(u == NULL) {
	rv = FALSE;
    } else if(strcmp(argv[1],u->password)==0) {
    
      rv = user_remove(((Server*)argv[argc+1])->users,argv[0]);

    }

  } else {
    gchar *str = 
      g_strdup_printf(_("wrong number of arguments got %d need %d"),argc,2);
    g_warning(str);
    g_free(str);    
    
  }

  return rv;

}

gboolean us_user_change_password(gint argc,gchar *argv[]) {
   
  gboolean rv = FALSE;

  if(argc == 3) {
    User *u = user_get(((Server*)argv[argc+1])->users,argv[0]);
    
    if(u == NULL) {
	rv = FALSE;
    } else if(strcmp(argv[1],u->password)==0) {

      g_free(u->password);
      u->password = g_strdup(argv[2]);
      rv = TRUE;

    }

  } else {
    gchar *str = 
      g_strdup_printf(_("wrong number of arguments got %d need %d"),argc,3);
    g_warning(str);
    g_free(str);    
    
  }

  return rv;
 
}


void print_name(gpointer key,gpointer value,gpointer user_data) {

  g_print("  %s: %s %s %s %d\n",
          (gchar*)key,(gchar*)((User*)value)->name,
          (gchar*)((User*)value)->password,
	  ((User*)value)->c->ip,((User*)value)->c->port);
  
}

gboolean us_hack_list_users(gint argc,gchar *argv[]) {

  gboolean rv = TRUE;

  g_print("users: (%d)\n----\n",
          g_hash_table_size(((Server*)argv[argc+1])->users));
  g_hash_table_foreach(((Server*)argv[argc+1])->users,print_name,NULL);
  g_print("----\n");
  
  return rv;

}

user_state_enum us_parse_state_enum_arg(gchar *arg) {

  user_state_enum rv = -1;

  if(arg[0] == 'U') {
    gint i;

    for(i=0;i<N_USER_STATES;i++)
      if(strcmp(arg,user_state_string[i])==0) 
	rv = i;
    
  } else if((arg[0] >= 0) && (arg[0] <= 9)) {

    rv = atoi(arg);

  }

  return rv;

}
