#include <hack.h>

Hack *hack;

/* start and stop functions */
gboolean start_plugin(gint argc,gchar *argv[]) {

  Client *c = (Client*)argv[argc+1];
  
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(
       g_hash_table_lookup(c->plugin_buttons,"hack"))) == TRUE) {
    hack = hack_new();
    hack->c = c;
    hack_app_open_cb(NULL,hack);
    return TRUE;
  }

  current_error_message_set(_("The Hack plugin has already been loaded"));
  return FALSE;
  
}

gboolean stop_plugin(gint argc,gchar *argv[]) {

  Client *c = (Client*)argv[argc+1];

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(
       g_hash_table_lookup(c->plugin_buttons,"hack"))) == FALSE) {
    gtk_widget_destroy(hack->hack_app);
    return TRUE;
  }
  if(argc >= 1) {
    if(g_strcasecmp(argv[0],"free")==0) {
      hack_destroy(hack);
    }
  }
  
  current_error_message_set(_("The Hack plugin is already been unloaded"));
  return FALSE;
  
}


/* there's no specific network functions */


/* local functions */
Hack *hack_new(void) {

  Hack *new = (Hack*)g_malloc0(sizeof(Hack));

  return new;
  
}

void hack_destroy(Hack *h) {

  if(h == NULL) {
    return;
  }
  g_free(h);
  h = NULL;
  
}
  
void hack_call_func_cb(GtkWidget *widget,gpointer data) {

  Hack *h = (Hack*)data;
  Client *c = h->c;
  gchar *lib = gtk_editable_get_chars(GTK_EDITABLE(h->hack_lib_entry),0,-1);
  gchar *func = gtk_editable_get_chars(GTK_EDITABLE(h->hack_func_entry),0,-1);
  gchar *args = gtk_editable_get_chars(GTK_EDITABLE(h->hack_args_entry),0,-1);
  gchar **argv;

  if(c->server != NULL) {
    if((strlen(lib) > 0) && (strlen(func) > 0) && (strlen(args) > 0)) {
      argv = g_strsplit(args," ",0);
      call_remote_func(c->server,lib,func,argv);
      g_strfreev(argv);
    }
  } else {
    current_error_message_set(_("Not connected to server"));
    current_error_message_show();
  }

  g_free(lib);
  g_free(func);
  g_free(args);

}

void hack_stop_cb(GtkWidget *widget,gpointer data) {

  Hack *h = (Hack*)data;
  gchar *args[] = { "free", NULL, (gchar*)h->c };
  
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(g_hash_table_lookup(h->c->plugin_buttons,"hack")),FALSE);
  stop_plugin(1,(gchar**)args);

}

void hack_app_open_cb(GtkWidget *widget,gpointer data) {

  Hack *h = (Hack*)data;
  gchar *str;
  
  h->hack_app =
    gnome_app_new(PACKAGE,(str=g_strdup_printf(_("%s Hack"),PACKAGE)));  
  
  gtk_signal_connect(GTK_OBJECT(h->hack_app),"destroy",
		     GTK_SIGNAL_FUNC(hack_stop_cb),h);
  
  h->hack_table = gtk_table_new(3,5,FALSE);

  /* labels */
  h->hack_lib_label = gtk_label_new(_("library name"));
  h->hack_func_label = gtk_label_new(_("function name"));
  h->hack_args_label = gtk_label_new(_("arguments"));
  
  /* entries */
  h->hack_lib_entry = gtk_entry_new();
  h->hack_func_entry = gtk_entry_new();
  h->hack_args_entry = gtk_entry_new();
  
  /* the call button */
  h->hack_call_func_button = gtk_button_new_with_label(_("call function"));
  

  gtk_signal_connect(GTK_OBJECT(h->hack_call_func_button),"clicked",
		     GTK_SIGNAL_FUNC(hack_call_func_cb),h);    

  gtk_table_attach_defaults(GTK_TABLE(h->hack_table),
			    h->hack_lib_label,0,1,0,1);
  gtk_table_attach_defaults(GTK_TABLE(h->hack_table),
			    h->hack_func_label,0,1,1,2);
  gtk_table_attach_defaults(GTK_TABLE(h->hack_table),
			    h->hack_args_label,0,1,2,3);

  gtk_table_attach_defaults(GTK_TABLE(h->hack_table),
			    h->hack_lib_entry,1,2,0,1);
  gtk_table_attach_defaults(GTK_TABLE(h->hack_table),
			    h->hack_func_entry,1,2,1,2);
  gtk_table_attach_defaults(GTK_TABLE(h->hack_table),
			    h->hack_args_entry,1,2,2,3);
  gtk_table_attach_defaults(GTK_TABLE(h->hack_table),
			    h->hack_call_func_button,1,2,3,4);

  gnome_app_set_contents(GNOME_APP(h->hack_app),h->hack_table);
  
  gtk_widget_show_all(h->hack_app);
  
  g_free(str);
  
}

