#include <gnome.h>
#include <server.h>
#include <user.h>
#include <client.h>
#include <cur_error.h>


enum users_clist_columns {

    STATUS_COLUMN,
    NAME_COLUMN,
    N_COLUMNS

};

typedef struct _Talk {

  gchar *talk_fg_color;
  gchar *talk_bg_color;
  gchar *talk_bg_pixmap;
  gchar *talk_font;

  gint n_friends;
  gchar **friends;

  GtkWidget *talk_app,*talk_table;
  GtkWidget *talk_entry,*talk_text,*talk_clist;
  GList *to_users_list;

  Client *c;
  
} Talk;

extern Talk* talk;


/*
 * START AND STOP THE PLUGIN
 */

gboolean start_plugin(gint argc,gchar *argv[]);
gboolean stop_plugin(gint argc,gchar *argv[]);



/*
 * NETWORK FUNCTIONS, message transfer etc.
 */


/* argv[] = {
 *   from_name,
 *   to_name,
 *   message,
 *   (Connection*)connection,
 *   (ClientOrServer*)cos
 * }
 */
gboolean ta_send_message_through_server(gint argc,gchar *argv[]);

/* argv[] = {
 *   from_name,
 *   to_name,
 *   message,
 *   (Connection*)connection,
 *   (ClientOrServer*)cos
 * }
 */
gboolean ta_recv_message(gint argc,gchar *argv[]);

/* FIXME: not implemented yet */
gboolean ta_send_message_direct(); 



/*
 * LOCAL FUNCTIONS, GUI etc.
 */

Talk *talk_new(void);
void talk_destroy(Talk *t);

gint talk_user_name_compare_func(gconstpointer a,gconstpointer b);
void talk_select_user_cb(GtkCList *clist,gint row,gint column,
                         GdkEventButton *event,Talk *t);
void talk_unselect_user_cb(GtkCList *clist,gint row,gint column,
                           GdkEventButton *event,Talk *t);

void talk_send_message_cb(GtkWidget *widget,gpointer data);
gboolean talk_recv_message(Talk *t,gchar *from,gchar *message);

void talk_add_user_cb(GtkWidget *widget,gpointer data);
void talk_click_column_cb(GtkCList *clist, gint column, gpointer data);

void talk_app_open_cb(GtkWidget *widget,gpointer data);
void talk_app_destroy_cb(GtkWidget *widget,gpointer data);
void talk_app_toggle_cb(GtkWidget *widget,gpointer data);


