#ifndef QUEST_CLIENT_H
#define QUEST_CLIENT_H

#include <config.h>
#include <gnome.h>
#include <user.h>
#include <fileio.h>

typedef struct _Client {

  /* loaded_modules must be the first field */
  GHashTable *loaded_modules;

  GHashTable *users; 
  Connection *server;

  /* Session Management variables */
  GnomeClient *session_client;
  gchar *my_username, *my_password;
  gchar *my_server_ip;
  gint my_server_port;
  gchar *my_initial_state;

  /* Graphical User Interface */
  GtkWidget *app,*table;
  GtkWidget *plugin_table, *plugin_scroll;
  GHashTable *plugin_buttons;
  GtkWidget *connect_toggle;
  GtkWidget *state_option, *state_menu, *state_item[N_USER_STATES];
  GtkWidget *about_dialog, *about_href; 
  GtkWidget *prop_dialog;
  GtkWidget *prop_whoami_table, *prop_whoami_label,
    *prop_username_label, *prop_password_label,
    *prop_username_entry, *prop_password_entry;
  GtkWidget *prop_address_table, *prop_address_label,
    *prop_ip_label, *prop_port_label,
    *prop_ip_entry, *prop_port_entry;
  GtkWidget *prop_plugin_table, *prop_plugin_label,
    *prop_plugin_dir_label, *prop_plugin_dir_entry;
    
} Client;

Client *client_new(void);
void client_destroy(Client *c);

void client_init(Client* c,gchar *geometry);

void client_scan_plugins_cb(GtkWidget *widget,gpointer data);
void client_toggle_plugin_cb(GtkWidget *widget,gpointer data);

void client_state_option_changed_cb(GtkWidget *widget,gpointer data);
void client_destroy_cb(GtkWidget *widget,gpointer data);
void client_app_destroy_cb(GtkWidget *widget,gpointer data);

void client_connect_toggle_cb(GtkWidget *widget,gpointer data);
gboolean client_connect_cb(GtkWidget *widget,gpointer data);
gboolean client_disconnect_cb(GtkWidget *widget,gpointer data);

void client_prop_save_cb(GtkWidget *widget,GdkEvent *event,gpointer data);
void client_prop_load_cb(GtkWidget *widget,GdkEvent *event,gpointer data);
void client_prop_save_geometry_cb(GtkWidget *widget,GdkEvent *event,
                                  gpointer data);
void client_prop_load_geometry_cb(GtkWidget *widget,GdkEvent *event,
                                  gpointer data);

void about_dialog_cb(GtkWidget *widget,gpointer data);
void prop_dialog_cb(GtkWidget *widget,gpointer data);
void prop_dialog_changed_cb(GtkWidget *widget,gpointer data);

#endif /* QUEST_CLIENT_H */
