#ifndef QUEST_USER_H
#define QUEST_USER_H

#include <config.h>
#include <gnome.h>
#include <modules.h>
#include <net.h>

typedef enum _user_state_enum {

  USER_OFFLINE,
  USER_ONLINE,
  USER_AWAY,
  USER_INVISIBLE,

  /* a counter to check if user_states are valid */
  N_USER_STATES 

} user_state_enum;

extern gchar *user_state_string[];
extern gchar *user_state_string_nice[];

typedef struct _User {

  gchar *name;
  gchar *password;
  user_state_enum user_state;
  Connection *c;

} User;

guint user_hash_func(gconstpointer key);
gint user_compare_func(gconstpointer a,gconstpointer b);
gboolean user_remove_func(gpointer key,gpointer value,gpointer user_data);

User *user_new();
void user_destroy(User *user);

User *user_new_with_values(gchar *name,gchar *password,Connection *c);

gboolean user_add(GHashTable *users,User *user);
gboolean user_remove(GHashTable *users,gchar *name);
User *user_get(GHashTable *users,gchar *name);

#endif /* QUEST_USER_H */
