#include <config.h>
#include <server.h>

static int server_port = 4242;
static char* geometry = NULL;

struct poptOption options[] = {
  {
    "port",
    '\0',
    POPT_ARG_INT,
    &server_port,
    0,
    N_("Specify a port (default 4242)"),
    N_("PORT")
  },
  {
    "geometry",
    '\0',
    POPT_ARG_STRING,
    &geometry,
    0,
    N_("Specify the geometry of the main window"),
    N_("GEOMETRY (WIDTHxHEIGHT+X+Y)")
  },
  {
    NULL,
    '\0',
    0,
    NULL,
    0,
    NULL,
    NULL
  }
};

int main(int argc,char *argv[]) {
  
  Server *server = NULL;
 
  bindtextdomain(PACKAGE,GNOMELOCALEDIR);
  textdomain(PACKAGE);

  gnome_init_with_popt_table(PACKAGE,VERSION,argc,argv,options,0,NULL);

  server = server_new(server_port);
  server_init(server,geometry);

  gtk_main();

  return 0;
  
}
